"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("../../base");
const cli_1 = require("../../utils/cli");
const command_1 = require("../../utils/command");
class DeletePaymentDelegation extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(DeletePaymentDelegation);
            this.kit.defaultAccount = res.flags.account;
            const accounts = yield this.kit.contracts.getAccounts();
            yield (0, cli_1.displaySendTx)('deletePaymentDelegation', accounts.deletePaymentDelegation());
            console.log('Deleted payment delegation.');
        });
    }
}
exports.default = DeletePaymentDelegation;
DeletePaymentDelegation.description = "Removes a validator's payment delegation by setting benficiary and fraction to 0.";
DeletePaymentDelegation.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { account: command_1.Flags.address({ required: true }) });
DeletePaymentDelegation.args = [];
DeletePaymentDelegation.examples = [
    'delete-payment-delegation --account 0x5409ED021D9299bf6814279A6A1411A7e866A631',
];
//# sourceMappingURL=delete-payment-delegation.js.map