"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const base_1 = require("../../base");
class AccountList extends base_1.BaseCommand {
    constructor() {
        super(...arguments);
        this.requireSynced = false;
    }
    run() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(AccountList);
            // Retreive accounts from the connected Celo node.
            const allAddresses = !res.flags.local ? yield this.kit.connection.getAccounts() : [];
            // Get addresses from the local wallet.
            const localAddresses = ((_a = res.flags.local) !== null && _a !== void 0 ? _a : true) ? yield this.kit.connection.getLocalAccounts() : [];
            // Display the addresses.
            const localName = res.flags.useLedger ? 'Ledger' : 'Local';
            if (res.flags.local === undefined) {
                console.log('All Addresses: ', allAddresses);
            }
            if (!res.flags.local) {
                const nodeAddresses = allAddresses.filter((address) => !localAddresses.includes(address));
                console.log('Keystore Addresses: ', nodeAddresses);
            }
            if ((_b = res.flags.local) !== null && _b !== void 0 ? _b : true) {
                console.log(`${localName} Addresses: `, localAddresses);
            }
        });
    }
}
exports.default = AccountList;
AccountList.description = 'List the addresses from the node and the local instance';
AccountList.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { local: command_1.flags.boolean({
        allowNo: true,
        description: 'If set, only show local and hardware wallet accounts. Use no-local to only show keystore addresses.',
    }) });
//# sourceMappingURL=list.js.map