"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const offchain_data_wrapper_1 = require("@celo/identity/lib/offchain-data-wrapper");
const name_1 = require("@celo/identity/lib/offchain/accessors/name");
const command_1 = require("@oclif/command");
const base_1 = require("../../base");
const command_2 = require("../../utils/command");
const off_chain_data_1 = require("../../utils/off-chain-data");
class OffchainRead extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const { args: { address }, flags: { from, privateDEK }, } = this.parse(OffchainRead);
            const provider = new offchain_data_wrapper_1.BasicDataWrapper(from, this.kit);
            if (privateDEK) {
                this.kit.addAccount(privateDEK);
            }
            const nameApplication = privateDEK
                ? new name_1.PrivateNameAccessor(provider)
                : new name_1.PublicNameAccessor(provider);
            const data = yield nameApplication.read(address);
            console.log(data);
        });
    }
}
exports.default = OffchainRead;
OffchainRead.description = 'DEV: Reads the name from offchain storage';
OffchainRead.flags = Object.assign(Object.assign({}, off_chain_data_1.OffchainDataCommand.flags), { 
    // private accessor parameters
    from: command_2.Flags.address({ required: false }), privateDEK: command_1.flags.string({ required: false }) });
OffchainRead.args = [command_2.Args.address('address')];
OffchainRead.examples = ['offchain-read 0x...', 'offchain-read 0x... --from 0x... --privateKey 0x...'];
//# sourceMappingURL=offchain-read.js.map