"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const BaseWrapper_1 = require("@celo/contractkit/lib/wrappers/BaseWrapper");
const command_1 = require("@oclif/command");
const base_1 = require("../../base");
const cli_1 = require("../../utils/cli");
const command_2 = require("../../utils/command");
class SetPaymentDelegation extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(SetPaymentDelegation);
            this.kit.defaultAccount = res.flags.account;
            const accounts = yield this.kit.contracts.getAccounts();
            yield (0, cli_1.displaySendTx)('setPaymentDelegation', accounts.setPaymentDelegation(res.flags.beneficiary, (0, BaseWrapper_1.valueToFixidityString)(res.flags.fraction)));
        });
    }
}
exports.default = SetPaymentDelegation;
SetPaymentDelegation.description = "Sets a payment delegation beneficiary, an account address to receive a fraction of the validator's payment every epoch. The fraction must not be greater than 1.";
SetPaymentDelegation.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { account: command_2.Flags.address({ required: true }), beneficiary: command_2.Flags.address({ required: true }), fraction: command_1.flags.string({ required: true }) });
SetPaymentDelegation.args = [];
SetPaymentDelegation.examples = [
    'set-payment-delegation --account 0x5409ed021d9299bf6814279a6a1411a7e866a631 --beneficiary 0x6Ecbe1DB9EF729CBe972C83Fb886247691Fb6beb --fraction 0.1',
];
//# sourceMappingURL=set-payment-delegation.js.map