"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("../../base");
const config_1 = require("../../utils/config");
class Set extends base_1.BaseCommand {
    constructor() {
        super(...arguments);
        this.requireSynced = false;
    }
    run() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(Set);
            const curr = (0, config_1.readConfig)(this.config.configDir);
            const node = (_a = res.flags.node) !== null && _a !== void 0 ? _a : curr.node;
            const gasCurrency = res.flags.gasCurrency
                ? base_1.gasOptions[res.flags.gasCurrency]
                : curr.gasCurrency;
            (0, config_1.writeConfig)(this.config.configDir, {
                node,
                gasCurrency,
            });
        });
    }
}
exports.default = Set;
Set.description = 'Configure running node information for propogating transactions to network';
Set.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { node: Object.assign(Object.assign({}, base_1.BaseCommand.flags.node), { hidden: false }), gasCurrency: Object.assign(Object.assign({}, base_1.BaseCommand.flags.gasCurrency), { hidden: false }) });
Set.examples = [
    'set --node ws://localhost:2500',
    'set --node <geth-location>/geth.ipc',
    'set --gasCurrency cUSD',
    'set --gasCurrency CELO',
];
//# sourceMappingURL=set.js.map