"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const base_1 = require("../../base");
const cli_1 = require("../../utils/cli");
const command_2 = require("../../utils/command");
const DKG = require('./DKG.json');
class DKGDeploy extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(DKGDeploy);
            const web3 = this.kit.connection.web3;
            const dkg = new web3.eth.Contract(DKG.abi);
            yield (0, cli_1.displayWeb3Tx)('deployDKG', dkg.deploy({ data: DKG.bytecode, arguments: [res.flags.threshold, res.flags.phaseDuration] }), { from: res.flags.from });
        });
    }
}
exports.default = DKGDeploy;
DKGDeploy.description = 'Deploys the DKG smart contract';
DKGDeploy.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { phaseDuration: command_1.flags.integer({
        required: true,
        description: 'Duration of each DKG phase in blocks',
    }), threshold: command_1.flags.integer({ required: true, description: 'The threshold to use for the DKG' }), from: command_2.Flags.address({ required: true, description: 'Address of the sender' }) });
//# sourceMappingURL=deploy.js.map