"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const address_1 = require("@celo/utils/lib/address");
const command_1 = require("@oclif/command");
const fs_1 = __importDefault(require("fs"));
const base_1 = require("../../base");
const cli_1 = require("../../utils/cli");
const command_2 = require("../../utils/command");
const DKG = require('./DKG.json');
class DKGPublish extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(DKGPublish);
            const web3 = this.kit.connection.web3;
            const dkg = new web3.eth.Contract(DKG.abi, res.flags.address);
            const data = fs_1.default.readFileSync(res.flags.data).toString('hex');
            yield (0, cli_1.displayWeb3Tx)('publishData', dkg.methods.publish((0, address_1.ensureLeading0x)(data)), {
                from: res.flags.from,
            });
        });
    }
}
exports.default = DKGPublish;
DKGPublish.description = 'Publishes data for each phase of the DKG';
DKGPublish.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { data: command_1.flags.string({ required: true, description: 'Path to the data being published' }), address: command_2.Flags.address({ required: true, description: 'DKG Contract Address' }), from: command_2.Flags.address({ required: true, description: 'Address of the sender' }) });
//# sourceMappingURL=publish.js.map