"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("../../base");
const cli_1 = require("../../utils/cli");
const command_1 = require("../../utils/command");
const DKG = require('./DKG.json');
class DKGStart extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(DKGStart);
            const web3 = this.kit.connection.web3;
            const dkg = new web3.eth.Contract(DKG.abi, res.flags.address);
            yield (0, cli_1.displayWeb3Tx)('start', dkg.methods.start(), { from: res.flags.from });
            this.log('DKG Started!');
        });
    }
}
exports.default = DKGStart;
DKGStart.description = 'Starts the DKG';
DKGStart.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { address: command_1.Flags.address({ required: true, description: 'DKG Contract Address' }), from: command_1.Flags.address({ required: true, description: 'Address of the sender' }) });
//# sourceMappingURL=start.js.map