"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const contractkit_1 = require("@celo/contractkit");
const exchange_stable_base_1 = __importDefault(require("../../exchange-stable-base"));
const command_1 = require("../../utils/command");
class ExchangeEuros extends exchange_stable_base_1.default {
    init() {
        const _super = Object.create(null, {
            init: { get: () => super.init }
        });
        return __awaiter(this, void 0, void 0, function* () {
            this._stableCurrency = contractkit_1.StableToken.cEUR;
            yield _super.init.call(this);
        });
    }
}
exports.default = ExchangeEuros;
ExchangeEuros.description = 'Exchange Celo Euros for CELO via the stability mechanism';
ExchangeEuros.flags = Object.assign(Object.assign({}, exchange_stable_base_1.default.flags), { from: command_1.Flags.address({
        required: true,
        description: 'The address with Celo Euros to exchange',
    }), value: command_1.Flags.wei({
        required: true,
        description: 'The value of Celo Euros to exchange for CELO',
    }) });
ExchangeEuros.examples = [
    'euros --value 10000000000000 --from 0xc1912fEE45d61C87Cc5EA59DaE31190FFFFf232d',
    'euros --value 10000000000000 --forAtLeast 50000000000000 --from 0xc1912fEE45d61C87Cc5EA59DaE31190FFFFf232d',
];
//# sourceMappingURL=euros.js.map