"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const cli_ux_1 = require("cli-ux");
const base_1 = require("../../base");
class ExchangeShow extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const { flags: parsedFlags } = this.parse(ExchangeShow);
            cli_ux_1.cli.action.start('Fetching exchange rates...');
            const exchangeAmounts = yield this.kit.celoTokens.forStableCeloToken((info) => __awaiter(this, void 0, void 0, function* () {
                const exchange = yield this.kit.contracts.getContract(info.exchangeContract);
                return {
                    buy: yield exchange.getBuyTokenAmount(parsedFlags.amount, true),
                    sell: yield exchange.getBuyTokenAmount(parsedFlags.amount, false),
                };
            }));
            cli_ux_1.cli.action.stop();
            Object.entries(exchangeAmounts).forEach((element) => {
                this.log(`CELO/${element[0]}:`);
                this.log(`${parsedFlags.amount} CELO => ${element[1].buy} ${element[0]}`);
                this.log(`${parsedFlags.amount} ${element[0]} => ${element[1].sell} CELO`);
            });
        });
    }
}
exports.default = ExchangeShow;
ExchangeShow.description = 'Show the current exchange rates offered by the Exchange';
ExchangeShow.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { amount: command_1.flags.string({
        description: 'Amount of the token being exchanged to report rates for',
        default: '1000000000000000000',
    }) });
ExchangeShow.args = [];
ExchangeShow.examples = ['list'];
//# sourceMappingURL=show.js.map