"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const governance_1 = require("@celo/governance");
const command_1 = require("@oclif/command");
const fs_1 = require("fs");
const base_1 = require("../../base");
const cli_1 = require("../../utils/cli");
const command_2 = require("../../utils/command");
const governance_2 = require("../../utils/governance");
class TestProposal extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(TestProposal);
            const account = res.flags.from;
            this.kit.defaultAccount = account;
            const builder = new governance_1.ProposalBuilder(this.kit);
            // BUILD FROM JSON
            const jsonString = (0, fs_1.readFileSync)(res.flags.jsonTransactions).toString();
            const jsonTransactions = JSON.parse(jsonString);
            jsonTransactions.forEach((tx) => builder.addJsonTx(tx));
            const proposal = yield builder.build();
            (0, cli_1.printValueMapRecursive)(yield (0, governance_1.proposalToJSON)(this.kit, proposal));
            yield (0, governance_2.executeProposal)(proposal, this.kit, account);
        });
    }
}
exports.default = TestProposal;
TestProposal.description = 'Test a governance proposal';
TestProposal.hidden = true;
TestProposal.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { jsonTransactions: command_1.flags.string({
        required: true,
        description: 'Path to json transactions',
    }), from: command_2.Flags.address({ required: true, description: "Proposer's address" }) });
TestProposal.examples = [
    'test-proposal --from 0x47e172F6CfB6c7D01C1574fa3E2Be7CC73269D95 --jsonTransactions proposal.json',
];
//# sourceMappingURL=test-proposal.js.map