"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const chalk_1 = __importDefault(require("chalk"));
const base_1 = require("../../base");
const checks_1 = require("../../utils/checks");
const cli_1 = require("../../utils/cli");
const command_2 = require("../../utils/command");
class VotePartially extends base_1.BaseCommand {
    run() {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(VotePartially);
            const signer = res.flags.from;
            const id = res.flags.proposalID;
            this.kit.defaultAccount = signer;
            const governance = yield this.kit.contracts.getGovernance();
            yield (0, checks_1.newCheckBuilder)(this, signer)
                .isVoteSignerOrAccount()
                .proposalExists(id)
                .proposalInStage(id, 'Referendum')
                .runChecks();
            if (res.flags.yes == null && res.flags.no == null && res.flags.abstain == null) {
                console.log(chalk_1.default.red.bold('At least one vote choice needs to be > 0.'));
                return;
            }
            yield (0, cli_1.displaySendTx)('voteTx', yield governance.votePartially(id, (_a = res.flags.yes) !== null && _a !== void 0 ? _a : 0, (_b = res.flags.no) !== null && _b !== void 0 ? _b : 0, (_c = res.flags.abstain) !== null && _c !== void 0 ? _c : 0), {}, 'ProposalPartiallyVoted');
        });
    }
}
exports.default = VotePartially;
VotePartially.description = 'Vote partially on an approved governance proposal';
VotePartially.voteOptions = ['Abstain', 'No', 'Yes'];
VotePartially.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { proposalID: command_1.flags.string({ required: true, description: 'UUID of proposal to vote on' }), yes: command_1.flags.string({ description: 'Yes votes' }), no: command_1.flags.string({ description: 'No votes' }), abstain: command_1.flags.string({ description: 'Abstain votes' }), from: command_2.Flags.address({ required: true, description: "Voter's address" }) });
VotePartially.examples = [
    'vote-partially --proposalID 99 --yes 10 --no 20 --from 0x5409ed021d9299bf6814279a6a1411a7e866a631',
];
//# sourceMappingURL=votePartially.js.map