"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("../../base");
const cli_1 = require("../../utils/cli");
class List extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const grandaMento = yield this.kit.contracts.getGrandaMento();
            const proposals = yield grandaMento.getActiveProposalIds();
            if (!proposals.length) {
                console.log('No active Granda Mento proposals');
                return;
            }
            console.log('Active proposals:');
            const proposalsDetails = proposals.map((id) => grandaMento.getHumanReadableExchangeProposal(id));
            const res = yield Promise.all(proposalsDetails);
            res.map((proposalJSON) => {
                console.log('Proposal ID: ' + proposalJSON.id);
                (0, cli_1.printValueMap)(proposalJSON);
            });
        });
    }
}
exports.default = List;
List.description = 'List current active Granda Mento exchange proposals';
List.flags = Object.assign({}, base_1.BaseCommand.flags);
//# sourceMappingURL=list.js.map