"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const base_1 = require("../../base");
const checks_1 = require("../../utils/checks");
const cli_1 = require("../../utils/cli");
class Show extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const grandaMento = yield this.kit.contracts.getGrandaMento();
            const res = this.parse(Show);
            const proposalID = res.flags.proposalID;
            yield (0, checks_1.newCheckBuilder)(this).grandaMentoProposalExists(proposalID).runChecks();
            const proposal = yield grandaMento.getHumanReadableExchangeProposal(proposalID);
            (0, cli_1.printValueMap)(proposal);
        });
    }
}
exports.default = Show;
Show.description = 'Shows details of a Granda Mento exchange proposal';
Show.flags = Object.assign(Object.assign({}, base_1.BaseCommand.flags), { proposalID: command_1.flags.string({
        required: true,
        description: 'UUID of proposal to view',
    }) });
//# sourceMappingURL=show.js.map