"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const contractkit_1 = require("@celo/contractkit");
const base_1 = require("../../base");
const cli_1 = require("../../utils/cli");
class List extends base_1.BaseCommand {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(List);
            const sortedOracles = yield this.kit.contracts.getSortedOracles();
            const oracles = yield sortedOracles.getOracles(res.args.token).catch((e) => (0, cli_1.failWith)(e));
            console.log(oracles);
        });
    }
}
exports.default = List;
List.description = 'List oracle addresses for a given token';
List.flags = Object.assign({}, base_1.BaseCommand.flags);
List.args = [
    {
        name: 'token',
        required: true,
        description: 'Token to list the oracles for',
        default: contractkit_1.CeloContract.StableToken,
    },
];
List.example = ['list StableToken', 'list', 'list StableTokenEUR'];
//# sourceMappingURL=list.js.map