"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const contractkit_1 = require("@celo/contractkit");
const command_1 = require("@oclif/command");
const transfer_stable_base_1 = require("../../transfer-stable-base");
const helpers_1 = require("../../utils/helpers");
const stableTokenOptions = (0, helpers_1.enumEntriesDupWithLowercase)(Object.entries(contractkit_1.StableToken));
class TransferStable extends transfer_stable_base_1.TransferStableBase {
    init() {
        const _super = Object.create(null, {
            init: { get: () => super.init }
        });
        return __awaiter(this, void 0, void 0, function* () {
            const res = this.parse(TransferStable);
            const stableName = res.flags.stableToken;
            this._stableCurrency = stableTokenOptions[stableName];
            yield _super.init.call(this);
        });
    }
}
exports.default = TransferStable;
TransferStable.description = 'Transfer a stable token to a specified address.';
TransferStable.flags = Object.assign(Object.assign({}, transfer_stable_base_1.TransferStableBase.flags), { stableToken: command_1.flags.enum({
        options: Object.keys(stableTokenOptions),
        description: 'Name of the stable to be transfered',
    }) });
TransferStable.examples = [
    'stable --from 0xa0Af2E71cECc248f4a7fD606F203467B500Dd53B --to 0x5409ed021d9299bf6814279a6a1411a7e866a631 --value 1000000000000000000 --stableToken cStableTokenSymbol',
];
//# sourceMappingURL=stable.js.map