"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const errors_1 = require("@oclif/errors");
const prompts_1 = __importDefault(require("prompts"));
const hook = (opts) => __awaiter(void 0, void 0, void 0, function* () {
    if (['plugins:install', 'plugins:link'].includes(opts.Command.id || '')) {
        // Require @celo/* NPM scope for any package installation
        // If no args are passed in, default to oclif/plugin-plugins error handling
        if (opts.argv.length && !/(@celo\/.+)|(@clabs\/.+)/.test(opts.argv[0])) {
            throw new errors_1.CLIError('Only plugins published in the @celo/* and @clabs/* NPM scopes may currently be installed.');
        }
        // Ask for explicit confirmation to install any plugins
        const response = yield (0, prompts_1.default)({
            type: 'confirm',
            name: 'confirmation',
            message: 'Are you sure you want to install this plugin? (y/n)',
        });
        if (!response.confirmation) {
            console.info('Aborting due to user response');
            process.exit(0);
        }
    }
});
exports.default = hook;
//# sourceMappingURL=plugin-warning.js.map