"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeConfig = exports.getGasCurrency = exports.getNodeUrl = exports.readConfig = exports.configPath = exports.defaultConfig = void 0;
// tslint:disable:class-name max-classes-per-file
// TODO: investigate tslint issues
const fs = __importStar(require("fs-extra"));
const path = __importStar(require("path"));
const base_1 = require("../base");
exports.defaultConfig = {
    node: 'http://localhost:8545',
    gasCurrency: 'auto',
};
const configFile = 'config.json';
function configPath(configDir) {
    return path.join(configDir, configFile);
}
exports.configPath = configPath;
function readConfig(configDir) {
    if (fs.pathExistsSync(configPath(configDir))) {
        const existingConfig = fs.readJSONSync(configPath(configDir));
        const combinedConfig = Object.assign(Object.assign({}, exports.defaultConfig), existingConfig);
        if (combinedConfig.hasOwnProperty('nodeUrl')) {
            combinedConfig.node = combinedConfig.nodeUrl;
        }
        return combinedConfig;
    }
    else {
        return exports.defaultConfig;
    }
}
exports.readConfig = readConfig;
function getNodeUrl(configDir) {
    return readConfig(configDir).node;
}
exports.getNodeUrl = getNodeUrl;
function getGasCurrency(configDir) {
    return readConfig(configDir).gasCurrency;
}
exports.getGasCurrency = getGasCurrency;
function writeConfig(configDir, configObj) {
    if (!Object.keys(base_1.gasOptions).includes(configObj.gasCurrency)) {
        throw new Error('Invalid gas option');
    }
    fs.outputJSONSync(configPath(configDir), configObj);
}
exports.writeConfig = writeConfig;
//# sourceMappingURL=config.js.map